#include "Copy.h"

static off_t		find_begin(select)
t_select	*select;
{
  if (select->reverse == 0)
    return (select->begin);
  else 
    return (select->begin == 0 ? select->length : 0);
}

static off_t		find_length(select, temp_gmurf, begin)
t_select	*select;
t_tempgmurf	*temp_gmurf;
off_t		begin;
{
  if (select->reverse == 0)
    return (select->length);
  else
    return (((temp_gmurf->temp_size) / sizeof(t_sound_sample))  - (begin == 0 ? 0 : select->length) - 1);
}

int		copy(temp_gmurf, select)
t_tempgmurf	*temp_gmurf;
t_select	*select;
{
  int			selectfile;
  off_t			begin;
  off_t			length;
  t_sound_sample	buf[BUFFER_SIZE * 2];
  t_sound_sample	buf2[BUFFER_SIZE * 2];
  unsigned long	nb = 1;
  unsigned long cpt;
  unsigned long cpt2;
  unsigned long compt;
  
  if (select->is_selected == 0)
    return (0);
  selectfile	= open(select_file, O_CREAT | O_TRUNC | O_RDWR, 0644);
  begin		= find_begin(select);
  length	= find_length(select, temp_gmurf, begin);
  lseek(temp_gmurf->file, sizeof(t_sound_sample) * begin, SEEK_SET);
  cpt2 = 0;
  cpt  = begin;
  while (length > 0)
    {
      nb = read(temp_gmurf->file, buf, BUFFER_SIZE * sizeof(t_sound_sample)) / sizeof(t_sound_sample);
      for (compt = 0; compt < nb; compt++)
	{
	  cpt++;
	  if (((cpt >= select->begin) && (cpt <= select->begin + select->length - 
	      ((select->reverse == 1) && (begin == 0)) ? 1 : 0 ))^(select->reverse == 1))
	    {
	      buf2[cpt2++] = buf[compt];
	      if (cpt2 >= BUFFER_SIZE)
		{
		  write(selectfile, buf2, BUFFER_SIZE * sizeof(t_sound_sample));
		  cpt2 = 0;
		}
	    }
	}
      length -= nb;
    }
  write(selectfile, buf2, cpt2 * sizeof(t_sound_sample));
  lseek(selectfile, 0, SEEK_SET);
  return 0;
}















