/*
 * MixerTypes.h
 * 
 * _psl_
 *
 * last update: 02 17 98
 */

/*
 * Attention  la procdure add_point
 * 
 * Veiller  ne pas insrer de point d'une date infrieure 
 *  l'lment point
 */

#ifndef MIXER_TYPES
#define MIXER_TYPES

#include "TempGmurf.h"
#include "MixerCurvesProtos.h"
#include "Constants.h"
#include "DspLib.h"
#include "MixerProtos.h"

t_mixer_elt* new_mixer_elt(             /* Cre un nouveau lment de mixer */
			   t_dsp*,       /* dsp associ */
			   t_tempgmurf*, /* fichier temporaire associ */
			   t_mixer_info* /* informations associes */
			   );

t_mixer_elt* add_mixer_elt(             /* Ajoute 1 elt mixer  1 liste */
			   t_main_mixer*,  /* mixer principal */
			   t_dsp*,         /* dsp associ */
			   t_tempgmurf*,   /* fichier tmp associ */
			   t_mixer_info*   /* infos associes */
			   );

int remove_mixer_elt(             /* retire 1 elt mixer d'1 liste chane*/
		     t_main_mixer*, /* mixer principal */
		     t_mixer_elt*   /* lment  retirer */
		     );

int main_mixer_destroy( /* Dtruit un mixeur principal */
		       t_main_mixer* /* mixer  dtruire */
		       );

t_mixer_info* new_mixer_info( /* Nouvelles infos */
			     float, /* Volume de l'onde */
			     BOOL, /* frequence */
			     float, /* balance */
			     int /* Date de dpart */
			     );

t_tempgmurf* new_tempgmurf(    /* FONCTION TEMPORAIRE! */
			   char*, /* Nom du fichier tempgmurf */
			   char*  /* Nom du fichier d'origine */
			   );

t_main_mixer* new_main_mixer(  /* cre un nouveau mixer principal */
			     t_dsp*, /* dsp  assigner */
			     int,  /* volume */
			     int,  /* panning */
			     int,  /* frequence */
			     int   /* nb max de voix */
			    );

#endif
