#ifndef TEMP_GMURF
#define TEMP_GMURF
#include "Constants.h"
#include <unistd.h>

enum {
  IN_MIXER,
  IN_WE,
  IN_BOTH
} ;	


typedef struct s_tempgmurf t_tempgmurf;
struct s_tempgmurf
{
  char			tempname[MAX_NAME_SZ]; /* Nom du fichier temporaire */
  char			origname[MAX_NAME_SZ]; /* nom du fichier qui a ete ouvert au depart */
  int			file;                  /* descripteur */
  size_t		temp_size;	       /* Taille du fichier temporaire */
  /*** variables contenant les proprietes initales du fichier WAV ***/
  unsigned short	bits_per_sample;       /* Resolution: 8 ou 16 bits */
  unsigned short	chanels;               /* 1: mono _ 2: stereo */
  long			sample_rate;           /* Frequance d'echantillonage */ 
  size_t		position;              /* Position actuelle */
  int			connected;		/* Flag to know if there is a connection between The mixer element and the Wav Editor */ 
}; /* s_tempgmurf */

#endif




